# coding: utf-8

"""
    AIMMS PRO REST API

    OpenAPI Specification of the AIMMS PRO REST API

    The version of the OpenAPI document: v2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from aimms_openapi_client.models.entity_authorization import EntityAuthorization
from aimms_openapi_client.models.pro_aimms_entry import PROAimmsEntry
from aimms_openapi_client.models.pro_project import PROProject
from typing import Optional, Set
from typing_extensions import Self


class PROAppEntry(BaseModel):
    """
    PROAppEntry
    """  # noqa: E501

    aimms: Optional[PROAimmsEntry] = None
    app_icon_sas_url: Optional[StrictStr] = Field(default=None, alias="appIconSasUrl")
    attributes: Optional[Dict[str, StrictStr]] = None
    authorizations: Optional[List[EntityAuthorization]] = None
    description: Optional[StrictStr] = None
    existing: Optional[StrictInt] = None
    is_latest: Optional[StrictBool] = Field(default=None, alias="isLatest")
    project: Optional[PROProject] = None
    project_category: Optional[StrictStr] = Field(default=None, alias="projectCategory")
    stored_id: Optional[StrictStr] = Field(default=None, alias="storedId")
    __properties: ClassVar[List[str]] = [
        "aimms",
        "appIconSasUrl",
        "attributes",
        "authorizations",
        "description",
        "existing",
        "isLatest",
        "project",
        "projectCategory",
        "storedId",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PROAppEntry from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of aimms
        if self.aimms:
            _dict["aimms"] = self.aimms.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in authorizations (list)
        _items = []
        if self.authorizations:
            for _item_authorizations in self.authorizations:
                if _item_authorizations:
                    _items.append(_item_authorizations.to_dict())
            _dict["authorizations"] = _items
        # override the default output from pydantic by calling `to_dict()` of project
        if self.project:
            _dict["project"] = self.project.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PROAppEntry from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "aimms": (
                    PROAimmsEntry.from_dict(obj["aimms"])
                    if obj.get("aimms") is not None
                    else None
                ),
                "appIconSasUrl": obj.get("appIconSasUrl"),
                "attributes": obj.get("attributes"),
                "authorizations": (
                    [
                        EntityAuthorization.from_dict(_item)
                        for _item in obj["authorizations"]
                    ]
                    if obj.get("authorizations") is not None
                    else None
                ),
                "description": obj.get("description"),
                "existing": obj.get("existing"),
                "isLatest": obj.get("isLatest"),
                "project": (
                    PROProject.from_dict(obj["project"])
                    if obj.get("project") is not None
                    else None
                ),
                "projectCategory": obj.get("projectCategory"),
                "storedId": obj.get("storedId"),
            }
        )
        return _obj
